import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataSnowflakeCurrentRoleConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/snowflake/d/current_role#id DataSnowflakeCurrentRole#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/snowflake/d/current_role snowflake_current_role}
*/
export declare class DataSnowflakeCurrentRole extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "snowflake_current_role";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/snowflake/d/current_role snowflake_current_role} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataSnowflakeCurrentRoleConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataSnowflakeCurrentRoleConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get name(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
